#include "at90can128.h"

#define ADC __vector_25

extern "C"{
	void ADC() __attribute__ ((signal));
};

AT90CAN128 *atmega = reinterpret_cast<AT90CAN128 *> (0);

int main(){

	atmega->ddrb  = 0xff;    //seta saida para os LEDs
	atmega->portb = 0xaa;    //inicia os LEDs

	atmega->portf = 0x00;

	atmega->admux |= 0x07;	 //utilizar pino 7
	atmega->admux |= 0xc0;	 //utilizar voltagem interna (2.56V)
	atmega->admux |= 0x20;	 //left adjust

	atmega->adcsrb &= 0xf8;  //modo de operacao = free running

	atmega->sreg |= 0x80; 	 //habilita interrupcoes

	atmega->adcsra |= 0x07;	 //seta frequencia de amostragem (128)
	atmega->adcsra |= 0x08;	 //habilita interrupcao ADC
	atmega->adcsra |= 0x20;	 //habilita auto trigger do ADC
	atmega->adcsra |= 0x80;	 //ativa o ADC
	atmega->adcsra |= 0x40;	 //comeca a conversao

	while(1);
	return 0;
}

void ADC() {
	atmega->portb = atmega->adch; //leds = valor da conversao
}
